var CLIP_Device =
{
	new : func(designation, model_element, model_index=0)
	{
        var obj = {parents : [CLIP_Device] };
        obj.designation = designation;
        obj.model_element = model_element;
		obj.gascellInit = [];
		obj.GS = [];
		obj.my_canvas = canvas.new({
			"name": designation,   # The name is optional but allow for easier identification
			"size": [1024, 1024], # Size of the underlying texture (should be a power of 2, required) [Resolution]
			"view": [702, 512],  # Virtual resolution (Defines the coordinate system of the canvas [Dimensions]
			"mipmapping": 0       # Enable mipmapping (optional)
		});
		obj.my_canvas.addPlacement({"node": "ReportBlock"});
		obj.my_canvas.set("background", "#f0f0f0");

		obj.root = obj.my_canvas.createGroup();

		var filename = "/Aircraft/SL20/Instruments/ClipBoard/Gaszellen.svg";
		obj.svg_symbol = obj.root.createChild('group');
		canvas.parsesvg(obj.svg_symbol, filename);
		obj.PageIndex = 1;
		obj.svg_symbol.setTranslation(0, 100);
		obj.Page1 = obj.svg_symbol.getElementById("Page1");
		append(obj.GS, obj.svg_symbol.getElementById("GS01"));
		append(obj.GS, obj.svg_symbol.getElementById("GS02"));
		append(obj.GS, obj.svg_symbol.getElementById("GS03"));
		append(obj.GS, obj.svg_symbol.getElementById("GS04"));
		append(obj.GS, obj.svg_symbol.getElementById("GS05"));
		append(obj.GS, obj.svg_symbol.getElementById("GS06"));
		append(obj.GS, obj.svg_symbol.getElementById("GS07"));
		append(obj.GS, obj.svg_symbol.getElementById("GS08"));
		append(obj.GS, obj.svg_symbol.getElementById("GS09"));
		append(obj.GS, obj.svg_symbol.getElementById("GS10"));
		append(obj.GS, obj.svg_symbol.getElementById("GS11"));
		append(obj.GS, obj.svg_symbol.getElementById("GS12"));
		append(obj.GS, obj.svg_symbol.getElementById("GS13"));
		append(obj.GS, obj.svg_symbol.getElementById("GS14"));
		append(obj.GS, obj.svg_symbol.getElementById("GS15"));
		append(obj.GS, obj.svg_symbol.getElementById("GS16"));
		append(obj.GS, obj.svg_symbol.getElementById("GS17"));
		append(obj.GS, obj.svg_symbol.getElementById("GS18"));
		obj.Page2 = obj.svg_symbol.getElementById("Page2");
		obj.Ta0 = obj.svg_symbol.getElementById("Tank");
		obj.TaG = obj.svg_symbol.getElementById("Reichweite");
		obj.TaD = obj.svg_symbol.getElementById("Strecke");
		obj.TaV = obj.svg_symbol.getElementById("Verbrauch");
		obj.Oxy = obj.svg_symbol.getElementById("Oxygen");
		obj.Page2.hide();
		obj.Page3 = obj.svg_symbol.getElementById("Page3");
		obj.CoG = obj.svg_symbol.getElementById("CoG");
		obj.CoGOrigin = obj.svg_symbol.getElementById("CoGOrigin");
		obj.CoGBase = 668.66406;
		obj.COGLen = 666.0;
		obj.TSchwer = obj.svg_symbol.getElementById("TextSchwere");
		obj.TBallast = obj.svg_symbol.getElementById("TextBallast");
		obj.Page3.hide();
		obj.Page4 = obj.svg_symbol.getElementById("Page4");
		obj.WDir = obj.svg_symbol.getElementById("WDir");
		obj.WStrength = obj.svg_symbol.getElementById("WStrength");
		obj.WTemp = obj.svg_symbol.getElementById("WTemp");
		obj.Page4.hide();

		obj.Page5 = obj.svg_symbol.getElementById("Page5");
		obj.KursText = obj.svg_symbol.getElementById("KursText");
		obj.HoeheText = obj.svg_symbol.getElementById("HoeheText");
		obj.FahrtText = obj.svg_symbol.getElementById("FahrtText");
		obj.ZielText = obj.svg_symbol.getElementById("ZielText");
		obj.EntfernungText = obj.svg_symbol.getElementById("EntfernungText");
		obj.AnkunftText = obj.svg_symbol.getElementById("AnkunftText");
		obj.Page5.hide();

		obj.Page6 = obj.svg_symbol.getElementById("Page6");
		obj.KursErteilt = obj.svg_symbol.getElementById("KursErteilt");
		obj.AWinkelErteilt = obj.svg_symbol.getElementById("AWinkelErteilt");
		obj.FahrtErteilt = obj.svg_symbol.getElementById("FahrtErteilt");
		obj.SteigtErteilt = obj.svg_symbol.getElementById("SteigtErteilt");
		obj.KursIst = obj.svg_symbol.getElementById("KursIst");
		obj.AWinkelIst = obj.svg_symbol.getElementById("AWinkelIst");
		obj.FahrtIst = obj.svg_symbol.getElementById("FahrtIst");
		obj.SteigtIst = obj.svg_symbol.getElementById("SteigtIst");
		obj.AutoLand = obj.svg_symbol.getElementById("AutoLand");
		obj.Page6.hide();

		obj.Page7 = obj.svg_symbol.getElementById("Page7");
		obj.Eng1Th = obj.svg_symbol.getElementById("Eng1Th");
		obj.Eng1RPM = obj.svg_symbol.getElementById("Eng1RPM");
		obj.Eng1Tem = obj.svg_symbol.getElementById("Eng1Tem");
		obj.Eng2Th = obj.svg_symbol.getElementById("Eng2Th");
		obj.Eng2RPM = obj.svg_symbol.getElementById("Eng2RPM");
		obj.Eng2Tem = obj.svg_symbol.getElementById("Eng2Tem");
		obj.Eng3Th = obj.svg_symbol.getElementById("Eng3Th");
		obj.Eng3RPM = obj.svg_symbol.getElementById("Eng3RPM");
		obj.Eng3Tem = obj.svg_symbol.getElementById("Eng3Tem");
		obj.Eng4Th = obj.svg_symbol.getElementById("Eng4Th");
		obj.Eng4RPM = obj.svg_symbol.getElementById("Eng4RPM");
		obj.Eng4Tem = obj.svg_symbol.getElementById("Eng4Tem");
		obj.Eng5Th = obj.svg_symbol.getElementById("Eng5Th");
		obj.Eng5RPM = obj.svg_symbol.getElementById("Eng5RPM");
		obj.Eng5Tem = obj.svg_symbol.getElementById("Eng5Tem");
		obj.Page7.hide();

		obj.SVGButton = obj.svg_symbol.getElementById("PageDown");
		obj.SVGButton.setTranslation(0, -100);
		obj.SVGButton.addEventListener("click", func {
			obj.PageChange(-1);
		});
		obj.SVGButton.hide();

		obj.SVGButton2 = obj.svg_symbol.getElementById("PageUp");
		obj.SVGButton2.setTranslation(0, -100);
		obj.SVGButton2.addEventListener("click", func {
			obj.PageChange(1);
		});
		obj.SVGButton2.hide();
		
		obj.my_canvas.addEventListener("wheel", func(e) {
			obj.PageChange(e.deltaY);
		});

		obj.uTimer = maketimer(1, func obj.update());
        return obj;
	},
	init : func
    {
		for (var i = 0; i < 18; i = i + 1)
		{
			append(me.gascellInit, getprop("fdm/jsbsim/buoyant_forces/gas-cell[" ~ i ~ "]/contents-mol"));
		}
		var moveO = me.COGLen * (getprop("fdm/jsbsim/inertia/cg-x-in") / 7795.276);
		me.CoGOrigin.setTranslation(-moveO, 0);
		me.uTimer.start();
	},
	reinit : func
    {
		me.uTimer.stop();
		me.gascellInit = [];
		for (var i = 0; i < 18; i = i + 1)
		{
			append(me.gascellInit, getprop("fdm/jsbsim/buoyant_forces/gas-cell[" ~ i ~ "]/contents-mol"));
		}
		var moveO = me.COGLen * (getprop("fdm/jsbsim/inertia/cg-x-in") / 7795.276);
		me.CoGOrigin.setTranslation(-moveO, 0);
		me.uTimer.start();
	},
	drawGauge : func(index)
	{
		var object = me.GS[index];
		if (getprop("/controls/gas/destroypressure[" ~ index ~ "]") > 0.5)
		{
			object.set("fill", "red");
		}
		else
		{
			if (getprop("/controls/gas/overpressure[" ~ index ~ "]") > 0.5)
			{
				var actPressure = getprop("fdm/jsbsim/buoyant_forces/gas-cell[" ~ index ~ "]/overpressure");
				var maxPressure = getprop("/controls/gas/max-overpressure");
				object.setColorFill([1, 1.0 - math.min(math.max(actPressure, 0) / maxPressure, 1), 0]);
			}
			else
				object.set("fill", "green");
		}
		var scaleGS = getprop("fdm/jsbsim/buoyant_forces/gas-cell[" ~ index ~ "]/contents-mol") / me.gascellInit[index];
		object.setScale(1, scaleGS);
		object.setTranslation(0, (120 - 120 * scaleGS) * 2);
	},
	update : func
    {
		if (me.PageIndex == 1)
		{
			for (var i = 0; i < 18; i = i + 1)
			{
				me.drawGauge(i);
			}
		}
		else if (me.PageIndex == 2)
		{
			me.Ta0.setText(sprintf("%i L", getprop("/consumables/fuel/total-fuel-gal_us") * 3.785411784));
			var total = getprop("/consumables/fuel/tank[0]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[1]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[2]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[3]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[4]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[5]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[6]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[7]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[8]/capacity-gal_us");
			total += getprop("/consumables/fuel/tank[9]/capacity-gal_us");
			var used = total * (1 - getprop("/consumables/fuel/total-fuel-norm"));
			var dist = getprop("/instrumentation/gps/odometer") * 1.852;
			if (dist != 0)
			{
				var lperKm = used / dist;
				if (lperKm != 0)
				{
					var kmRest = (total * getprop("/consumables/fuel/total-fuel-norm")) / lperKm;
					me.TaG.setText(sprintf("%.1f km", kmRest));
				}
				me.TaD.setText(sprintf("%.1f km", dist));
			}
			var flow = getprop("/engines/engine[0]/fuel-flow-gph");
			flow = flow + getprop("/engines/engine[1]/fuel-flow-gph");
			flow = flow + getprop("/engines/engine[2]/fuel-flow-gph");
			flow = flow + getprop("/engines/engine[3]/fuel-flow-gph");
			flow = flow + getprop("/engines/engine[4]/fuel-flow-gph");
			me.TaV.setText(sprintf("%.1f L/Std", flow * 3.785411784));
			var seconds = getprop("/sim/rendering/redout/oxygen-count");
			var retString = "leer";
			if (seconds > 0)
			{
				var hours = math.floor(seconds / 3600);
				var minutes = math.floor((seconds - (hours * 3600)) / 60);
				retString = sprintf("%2i Stunden ", hours) ~ sprintf("%2i Minuten", minutes);
			}
			me.Oxy.setText(retString);
		}
		else if (me.PageIndex == 3)
		{
			var move = me.COGLen * (getprop("fdm/jsbsim/inertia/cg-x-in") / 7795.276);
			me.CoG.setTranslation(-move, 0);
			var sw = getprop("/fdm/jsbsim/static-condition/net-lift-lbs") * 0.453;
			if (sw < 0)
			{
				me.TSchwer.setText(sprintf("Schiff ist %.1f kg schwer", math.abs(sw)));
			}
			else
			{
				me.TSchwer.setText(sprintf("Schiff ist %.1f kg leicht", sw));
			}
			me.TBallast.setText(sprintf("Verbleibender Ballast %.1f kg", getprop("/fdm/jsbsim/static-condition/net-weight") * 0.453));
		}
		else if (me.PageIndex == 4)
		{
			me.WDir.setText(sprintf("%.1f", getprop("/environment/wind-from-heading-deg")));
			me.WStrength.setText(sprintf("%.1f", getprop("/environment/wind-speed-kmh")));
			me.WTemp.setText(sprintf("%.1f", getprop("/environment/temperature-degc")));
		}
		else if (me.PageIndex == 5)
		{
			var gearPos = getprop("/gear/gear[0]/zoffset-m") - getprop("/gear/gear[0]/compression-m");
			var aglComp = gearPos + (getprop("/fdm/jsbsim/inertia/cg-z-in") * 2.54) / 100.0;
			me.KursText.setText(sprintf("%.1f °", getprop("/orientation/track-deg")));
			me.HoeheText.setText(sprintf("%.1f m", getprop("/position/altitude-agl-ft") * 0.3048 - aglComp));
			me.FahrtText.setText(sprintf("%.1f Km/h", getprop("/instrumentation/gps/indicated-ground-speed-kt") * 1.852));
			if (getprop("/instrumentation/gps/wp/wp[1]/valid"))
			{
				me.ZielText.setText(sprintf("%s", getprop("/instrumentation/gps/wp/wp[1]/ID")));
				me.EntfernungText.setText(sprintf("%.1f Km", getprop("/instrumentation/gps/wp/wp[1]/distance-nm") * 1.852));
				me.AnkunftText.setText(sprintf("%s", getprop("/instrumentation/gps/wp/wp[1]/TTW")));
			}
			else
			{
				me.ZielText.setText("");
				me.EntfernungText.setText("");
				me.AnkunftText.setText("");
			}
		}
		else if (me.PageIndex == 6)
		{
			if (getprop("/autopilot/locks/heading-enable") and getprop("/autopilot/locks/heading-dg-hold"))
			{
				me.KursErteilt.setText(sprintf("%.1f°", getprop("/autopilot/settings/heading-bug-deg")));
			}
			else if (getprop("/autopilot/locks/heading-enable") and getprop("/autopilot/locks/heading-true-hold"))
			{
				me.KursErteilt.setText(sprintf("%.1f°", getprop("/autopilot/settings/true-heading-deg")));
			}
			else
			{
				me.KursErteilt.setText("");
			}
			if (getprop("/autopilot/locks/altitude-enable"))
			{
				if (getprop("/autopilot/locks/altitude-pitch") or getprop("/autopilot/locks/altitude-speed"))
				{
					me.AWinkelErteilt.setText(sprintf("%.1f°", getprop("/autopilot/settings/target-pitch-deg")));
				}
			}
			else
			{
				me.AWinkelErteilt.setText("");
			}
			if (getprop("/autopilot/locks/speed") == "speed-with-throttle")
			{
				me.FahrtErteilt.setText(sprintf("%.1f Km/h", getprop("/autopilot/settings/target-speed-kmh")));
			}
			else
			{
				me.FahrtErteilt.setText("");
			}
			if (getprop("/autopilot/locks/altitude-enable") and getprop("/autopilot/locks/altitude-speed"))
			{
				me.SteigtErteilt.setText(sprintf("%.1f m/s", getprop("/autopilot/settings/vertical-speed-fps")));
			}
			else
			{
				me.SteigtErteilt.setText("");
			}
			if (getprop("/autopilot/settings/autoland") == 0)
			{
				me.AutoLand.setText("Aus");
			}
			else
			{
				me.AutoLand.setText("Ein");
			}
			me.KursIst.setText(sprintf("%.1f °", getprop("/orientation/track-deg")));
			me.AWinkelIst.setText(sprintf("%.1f°", getprop("/orientation/pitch-deg")));
			me.FahrtIst.setText(sprintf("%.1f Km/h", getprop("/instrumentation/gps/indicated-ground-speed-kt") * 1.852));
			me.SteigtIst.setText(sprintf("%.1f m/s", getprop("/velocities/vertical-speed-fps") / 3.28084));
		}
		else if (me.PageIndex == 7)
		{
			me.Eng1Th.setText(sprintf("%.1f", getprop("/controls/engines/engine[0]/throttle") * 100));
			me.Eng1RPM.setText(sprintf("%.1f U/min", getprop("/engines/engine[0]/rpm")));
			me.Eng1Tem.setText(sprintf("%.1f°", (getprop("/engines/engine[0]/oil-temperature-degf") - 32) * 5/9));
			me.Eng2Th.setText(sprintf("%.1f", getprop("/controls/engines/engine[1]/throttle") * 100));
			me.Eng2RPM.setText(sprintf("%.1f U/min", getprop("/engines/engine[1]/rpm")));
			me.Eng2Tem.setText(sprintf("%.1f°", (getprop("/engines/engine[1]/oil-temperature-degf") - 32) * 5/9));
			me.Eng3Th.setText(sprintf("%.1f", getprop("/controls/engines/engine[2]/throttle") * 100));
			me.Eng3RPM.setText(sprintf("%.1f U/min", getprop("/engines/engine[2]/rpm")));
			me.Eng3Tem.setText(sprintf("%.1f°", (getprop("/engines/engine[2]/oil-temperature-degf") - 32) * 5/9));
			me.Eng4Th.setText(sprintf("%.1f", getprop("/controls/engines/engine[3]/throttle") * 100));
			me.Eng4RPM.setText(sprintf("%.1f U/min", getprop("/engines/engine[3]/rpm")));
			me.Eng4Tem.setText(sprintf("%.1f°", (getprop("/engines/engine[3]/oil-temperature-degf") - 32) * 5/9));
			me.Eng5Th.setText(sprintf("%.1f", getprop("/controls/engines/engine[4]/throttle") * 100));
			me.Eng5RPM.setText(sprintf("%.1f U/min", getprop("/engines/engine[4]/rpm")));
			me.Eng5Tem.setText(sprintf("%.1f°", (getprop("/engines/engine[4]/oil-temperature-degf") - 32) * 5/9));
		}
	},
	PageChange : func(d)
	{
		me.Page1.hide();
		me.Page2.hide();
		me.Page3.hide();
		me.Page4.hide();
		me.Page5.hide();
		me.Page6.hide();
		me.Page7.hide();
		if (d < 0)
		{
			me.PageIndex = me.PageIndex - 1;
			if (me.PageIndex < 1)
			{
				me.PageIndex = 7;
			}
		}
		else
		{
			me.PageIndex = me.PageIndex + 1;
			if (me.PageIndex > 7)
			{
				me.PageIndex = 1;
			}
		}
		if (me.PageIndex == 1)
		{
			me.Page1.show();
		}
		else if (me.PageIndex == 2)
		{
			me.Page2.show();
		}
		else if (me.PageIndex == 3)
		{
			me.Page3.show();
		}
		else if (me.PageIndex == 4)
		{
			me.Page4.show();
		}
		else if (me.PageIndex == 5)
		{
			me.Page5.show();
		}
		else if (me.PageIndex == 6)
		{
			me.Page6.show();
		}
		else if (me.PageIndex == 7)
		{
			me.Page7.show();
		}
	},
	showMDlg : func()
	{
		var dlg = canvas.Window.new([600, 400], "dialog").set("resize", 0).set("title", "Notizblock");
		dlg.setCanvas(me.my_canvas);
		me.SVGButton.show();
		me.SVGButton2.show();
		dlg.owner = me;
		dlg.del = func {
			me.owner.SVGButton.hide();
			me.owner.SVGButton2.hide();
			call(canvas.Window.del, [], me);
		};
	}
};

var CLIP =  CLIP_Device.new("Report", "ReportBlock",0);

setlistener("/sim/signals/fdm-initialized", func { CLIP.init();
});
