var CLIPFunk_Device =
{
	new : func(designation, model_element, model_index=0)
	{
        var obj = {parents : [CLIPFunk_Device] };
        obj.designation = designation;
        obj.model_element = model_element;
		obj.navLines = [];
		obj.Navaids = [];
		obj.my_canvas = canvas.new({
			"name": designation,   # The name is optional but allow for easier identification
			"size": [1024, 1024], # Size of the underlying texture (should be a power of 2, required) [Resolution]
			"view": [702, 512],  # Virtual resolution (Defines the coordinate system of the canvas [Dimensions]
			"mipmapping": 0       # Enable mipmapping (optional)
		});
		obj.my_canvas.addPlacement({"node": "ReportFunk"});
		obj.my_canvas.set("background", "#f0f0f0");

		obj.root = obj.my_canvas.createGroup();

		var filename = "/Aircraft/SL20/Instruments/Funk/Clip/Gaszellen.svg";
		obj.svg_symbol = obj.root.createChild('group');
		canvas.parsesvg(obj.svg_symbol, filename);
		obj.PageIndex = 1;
		obj.svg_symbol.setTranslation(0, 100);
		obj.Page1 = obj.svg_symbol.getElementById("Page1");
		obj.ADFFreq = obj.svg_symbol.getElementById("ADFFreq");
		obj.ADFIdent = obj.svg_symbol.getElementById("ADFIdent");
		obj.ADFName = obj.svg_symbol.getElementById("ADFName");
		obj.ADFDir = obj.svg_symbol.getElementById("ADFDir");
		obj.ADFKurs = obj.svg_symbol.getElementById("ADFKurs");
		obj.ButtonSteuer = obj.svg_symbol.getElementById("ButtonSteuer");
		obj.ButtonSteuer.addEventListener("click", func {
			var dir = getprop("/instrumentation/adf[0]/rotation-deg");
			var kurs = geo.normdeg(getprop("/orientation/heading-deg") + dir);
			setprop("autopilot/settings/heading-bug-deg", kurs);
		});
		obj.ButtonSteuer.addEventListener("mouseover", func {
			obj.ButtonSteuer.setColor(255, 0, 0);
			obj.ButtonSteuer.update();
		});
		obj.ButtonSteuer.addEventListener("mouseout", func {
			obj.ButtonSteuer.setColor(0, 0, 0);
			obj.ButtonSteuer.update();
		});

		obj.Page2 = obj.svg_symbol.getElementById("Page2");
		obj.COMFreq = obj.svg_symbol.getElementById("COMFreq");
		obj.COMIdent = obj.svg_symbol.getElementById("COMIdent");
		obj.COMName = obj.svg_symbol.getElementById("COMName");
		obj.COMDir = obj.svg_symbol.getElementById("COMDir");
		obj.COMDir2 = obj.svg_symbol.getElementById("COMDir2");
		obj.Page2.hide();

		obj.Page3 = obj.svg_symbol.getElementById("Page3");
		append(obj.navLines, obj.svg_symbol.getElementById("Nav1"));
		append(obj.navLines, obj.svg_symbol.getElementById("Nav2"));
		append(obj.navLines, obj.svg_symbol.getElementById("Nav3"));
		append(obj.navLines, obj.svg_symbol.getElementById("Nav4"));
		append(obj.navLines, obj.svg_symbol.getElementById("Nav5"));
		obj.Page3.hide();

		obj.SVGButton = obj.svg_symbol.getElementById("PageDown");
		obj.SVGButton.setTranslation(0, -100);
		obj.SVGButton.addEventListener("click", func {
			obj.PageChange(-1);
		});
		obj.SVGButton.hide();

		obj.SVGButton2 = obj.svg_symbol.getElementById("PageUp");
		obj.SVGButton2.setTranslation(0, -100);
		obj.SVGButton2.addEventListener("click", func {
			obj.PageChange(1);
		});
		obj.SVGButton2.hide();
		
		obj.my_canvas.addEventListener("wheel", func(e) {
			obj.PageChange(e.deltaY);
		});

		obj.uTimer = maketimer(0.2, func obj.update());
        return obj;
	},
	init : func
    {
		me.uTimer.start();
	},
	reinit : func
    {
		if (getprop("/sim/signals/refill") > 0.5)
		{
			me.uTimer.stop();
			me.uTimer.start();
		}
	},
	update : func
    {
		if (me.PageIndex == 1)
		{
			me.ADFFreq.setText(sprintf("%.1f Khz", getprop("/instrumentation/adf[0]/frequencies/selected-khz")));
			me.ADFIdent.setText(sprintf("%s", getprop("/instrumentation/adf[0]/ident")));
			me.ADFName.setText(sprintf("%.1f", getprop("/instrumentation/adf[0]/volume-norm")));
			var dir = getprop("/instrumentation/adf[0]/rotation-deg");
			if (dir == 0)
			{
				me.ADFDir.setText(sprintf("%.1f Grad Voraus", getprop("/instrumentation/adf[0]/rotation-deg")));
			}
			else if (dir == 180)
			{
				me.ADFDir.setText(sprintf("%.1f Grad Achtern", getprop("/instrumentation/adf[0]/rotation-deg")));
			}
			else if (dir > 180)
			{
				me.ADFDir.setText(sprintf("%.1f Grad Backbord", 360 - getprop("/instrumentation/adf[0]/rotation-deg")));
			}
			else
			{
				me.ADFDir.setText(sprintf("%.1f Grad Steuerbord", getprop("/instrumentation/adf[0]/rotation-deg")));
			}
			var kurs = geo.normdeg(getprop("/orientation/heading-deg") + dir);
			me.ADFKurs.setText(sprintf("%.1f Grad", kurs));
		}
		else if (me.PageIndex == 2)
		{
			me.COMFreq.setText(sprintf("%.3f Mhz", getprop("/instrumentation/comm/frequencies/selected-mhz")));
			if (getprop("/instrumentation/comm/volume-norm") > 0.05)
			{
				me.COMIdent.setText(sprintf("%s", getprop("/instrumentation/comm/airport-id")));
				if (getprop("/sim/messages/atc") != nil)
				{
					var msg = getprop("/sim/messages/atc");
					var msg1 = "";
					var msg2 = "";
					if (size(msg) > 40)
					{
						msg1 = left(msg, 40);
						msg2 = substr(msg, 40);
						me.COMDir.setText(sprintf("%s", msg1));
						me.COMDir2.setText(sprintf("%s", msg2));
					}
					else
					{
						me.COMDir.setText(sprintf("%s", msg));
					}
				}
				else
				{
					me.COMDir.setText("");
					me.COMDir2.setText("");
				}
			}
			else
			{
				me.COMIdent.setText("");
				me.COMDir.setText("");
				me.COMDir2.setText("");
			}
			me.COMName.setText(sprintf("%.1f", getprop("/instrumentation/comm/volume-norm")));
		}
		else if (me.PageIndex == 3)
		{
			for (var b = 0; b < 5; b = b + 1)
			{
				me.navLines[b].setText("");
			}
			var nCount = size(me.Navaids);
			if (nCount > 0)
			{
				nCount = math.min(nCount, 5);
				for (var a = 0; a < nCount; a = a + 1)
				{
					var nav = me.Navaids[a];
					me.navLines[a].setText(sprintf("%s Kennung: %s %.1f Khz", nav.name, nav.id, nav.frequency / 100));
				}
			}
		}
	},
	PageChange : func(d)
	{
		me.Page1.hide();
		me.Page2.hide();
		me.Page3.hide();
		if (d < 0)
		{
			me.PageIndex = me.PageIndex - 1;
			if (me.PageIndex < 1)
			{
				me.PageIndex = 3;
			}
		}
		else
		{
			me.PageIndex = me.PageIndex + 1;
			if (me.PageIndex > 3)
			{
				me.PageIndex = 1;
			}
		}
		if (me.PageIndex == 1)
		{
			me.Page1.show();
		}
		else if (me.PageIndex == 2)
		{
			me.Page2.show();
		}
		else if (me.PageIndex == 3)
		{
			me.Page3.show();
			me.Navaids = findNavaidsWithinRange(50, "ndb");
		}
	},
	showMDlg : func()
	{
		var dlg = canvas.Window.new([600, 400], "dialog").set("resize", 0).set("title", "Notizblock Funk");
		dlg.setCanvas(me.my_canvas);
		me.SVGButton.show();
		me.SVGButton2.show();
		dlg.owner = me;
		dlg.del = func {
			me.owner.SVGButton.hide();
			me.owner.SVGButton2.hide();
			call(canvas.Window.del, [], me);
		};
	}
};

var CLIPFunk =  CLIPFunk_Device.new("ReportFunk", "ReportFunk",0);

setlistener("/sim/signals/fdm-initialized", func { CLIPFunk.init();
});
setlistener("/sim/signals/refill", func { CLIPFunk.reinit();
});
