var MAP_Device =
{
	new : func(designation, model_element, model_index=0)
	{
        var obj = {parents : [MAP_Device] };
        obj.designation = designation;
        obj.model_element = model_element;
		obj.zoom = 5;
		obj.map_type = 0;
        return obj;
	},
	changeType : func
	{
		me.map_type = me.map_type + 1;
		if (me.map_type > 1)
			me.map_type = 0;
		if (me.map_type == 0)
		{
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-OSM", 1);
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-STAMEN", 0);
		}
		else
		{
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-OSM", 0);
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-STAMEN", 1);
		}
		setprop("/sim/model/SL20/map-type", me.map_type);
		me.update();
	},
	changeZoom : func(d)
	{
		if (d < 0)
		{
			var range = me.TestMap.getRange();
			me.TestMap.setRange(range / me.range_step);
			setprop("/sim/model/SL20/map-zoom", range / me.range_step);
		}
		else
		{
			var range = me.TestMap.getRange();
			me.TestMap.setRange(range * me.range_step);
			setprop("/sim/model/SL20/map-zoom", range * me.range_step);
		}
		me.update();
	},
	init : func
    {
		me.my_canvas = canvas.new({
			"name": "Karte",   # The name is optional but allow for easier identification
			"size": [1024, 1024], # Size of the underlying texture (should be a power of 2, required) [Resolution]
			"view": [600, 400],  # Virtual resolution (Defines the coordinate system of the canvas [Dimensions]
			"mipmapping": 0       # Enable mipmapping (optional)
		});
		me.my_canvas.addPlacement({"node": "MDisplay"});
		me.my_canvas.set("background", "#f0f0f0");

		me.root = me.my_canvas.createGroup();
		me.TestMap = me.root.createChild("map");
		var SetLayerVisible = func(name,n=1)
		{
			me.TestMap.getLayer(name).setVisible(n);
		};
		var ctrl_ns = canvas.Map.Controller.get("Aircraft position");
		var source = ctrl_ns.SOURCES["map-dialog"];
		if (source == nil)
		{
			# TODO: amend
			var source = ctrl_ns.SOURCES["map-dialog"] = {
				getPosition: func subvec(geo.aircraft_position().latlon(), 0, 2),
				getAltitude: func getprop('/position/altitude-ft'),
				getHeading:  func {
					if (me.aircraft_heading)
						getprop('/orientation/heading-deg')
					else 0
					},
					aircraft_heading: 1,
				};
		}
		setlistener("/sim/gui/dialogs/SL20/map-canvas/aircraft-heading-up", func(n) {
			source.aircraft_heading = n.getBoolValue();
		}, 1);
		# Make it move with our aircraft:
		me.TestMap.setController("Aircraft position", "map-dialog");
		me.TestMap.setRange(me.zoom);
		me.TestMap.setScreenRange(200);
		me.TestMap.setTranslation(me.my_canvas.get("view[0]")/2, me.my_canvas.get("view[1]")/2);
		me.range_step = math.log10(me.TestMap.getRange());
		var Styles = {};
		Styles.get = func(type) return Styles[type];
		var Options = {};
		Options.get = func(type) return Options[type];
		Styles.FLT = {};
		Styles.FLT.line_width = 3;
		Options.FLT = {};
		var make_update_wrapper = func(name) {
		if (!contains(Options, name)) Options[name] = {};
		Options[name].update_wrapper = func(layer, fn) {
			fn();
			}
		}
		Styles.RTE = {};
		Styles.RTE.line_width = 2;
		Styles.WPT = {};
		Styles.WPT.scale_factor = 0.5;
		Styles.APT = {};
		Styles.APT.scale_factor = 0.4; # 40% (applied to whole group)
		Styles.APT.line_width = 3.0;
		Styles.APT.color_default = [0,0.6,0.85];  #rgb
		Styles.APT.label_font_color = Styles.APT.color_default;
		Styles.APT.label_font_size=28;
		var r = func(name,vis=1,zindex=nil) return caller(0)[0];
		var listeners = [];
		foreach(var type; [ r('OSM'), r('STAMEN') ])
		{
			me.TestMap.addLayer(factory: canvas.OverlayLayer, type_arg: type.name,
								visible: 0, priority: 1,
								style: Styles.get(type.name),
								options: Options.get(type.name) );
				(func {
				# Notify MapStructure about layer visibility changes:
				var name = type.name;
				props.globals.initNode("/sim/gui/dialogs/SL20/map-canvas/draw-"~name, 0, "BOOL");
				append(listeners,
					setlistener("/sim/gui/dialogs/SL20/map-canvas/draw-"~name,
						func(n) SetLayerVisible(name,n.getValue()))
				);
			})();
		}
		foreach(var type; [r('RTE'),r('WPT'),r('FLT'),r('APT')] )
		{
			if (1 and type.name != 'APS' and type.name != 'FLT') make_update_wrapper(type.name);
			me.TestMap.addLayer(factory: canvas.SymbolLayer, type_arg: type.name,
								visible: type.vis, priority: 4,
								style: Styles.get(type.name),
								options: Options.get(type.name) );
				(func {
					# Notify MapStructure about layer visibility changes:
					var name = type.name;
					props.globals.initNode("/sim/gui/dialogs/SL20/map-canvas/draw-"~name, type.vis, "BOOL");
					append(listeners,
						setlistener("/sim/gui/dialogs/SL20/map-canvas/draw-"~name,
							func(n) SetLayerVisible(name,n.getValue()))
				);
			})();
		}
		me.zoom = getprop("/sim/model/SL20/map-zoom");
		me.map_type = getprop("/sim/model/SL20/map-type");
		me.TestMap.setRange(me.zoom);
		if (me.map_type == 0)
		{
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-OSM", 1);
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-STAMEN", 0);
		}
		else
		{
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-OSM", 0);
			setprop("/sim/gui/dialogs/SL20/map-canvas/draw-STAMEN", 1);
		}
		setprop("/sim/gui/dialogs/SL20/map-canvas/draw-RTE", 1);
		setprop("/sim/gui/dialogs/SL20/map-canvas/draw-WPT", 1);
		setprop("/sim/gui/dialogs/SL20/map-canvas/draw-FLT", 1);
		setprop("/sim/gui/dialogs/SL20/map-canvas/draw-APT", 1);
		setprop("/sim/gui/dialogs/SL20/map-canvas/aircraft-heading-up", 0);

		var filenameA = "/Aircraft/SL20/Instruments/MovingMap/Arrow.svg";
		me.svg_symbolA = me.root.createChild('group');
		canvas.parsesvg(me.svg_symbolA, filenameA);
		me.svg_symbolA.setTranslation(64,64);
		me.svg_symbolA.set("z-index", 1);
		me.svg_symbolA.setScale(0.5);

		var filenameT = "/Aircraft/SL20/Instruments/MovingMap/Track.svg";
		me.svg_symbolT = me.root.createChild('group');
		canvas.parsesvg(me.svg_symbolT, filenameT);
		me.svg_symbolT.setTranslation(me.my_canvas.get("view[0]")/2, me.my_canvas.get("view[1]")/2);
		me.svg_symbolT.set("z-index", 1);

		var filename = "/Aircraft/SL20/Instruments/MovingMap/Zepp.svg";
		me.svg_symbol = me.root.createChild('group');
		canvas.parsesvg(me.svg_symbol, filename);
		me.svg_symbol.setTranslation(me.my_canvas.get("view[0]")/2, me.my_canvas.get("view[1]")/2);
		me.svg_symbol.set("z-index", 1);
		me.svg_symbol.setScale(0.3);
		me.svg_symbol.set("stroke", "red");
		me.my_canvas2 = canvas.new({
			"name": "KarteDescription",   # The name is optional but allow for easier identification
			"size": [1024, 1024], # Size of the underlying texture (should be a power of 2, required) [Resolution]
			"view": [505, 35],  # Virtual resolution (Defines the coordinate system of the canvas [Dimensions]
			"mipmapping": 0       # Enable mipmapping (optional)
		});
		me.my_canvas2.addPlacement({"node": "BottomKarte"});
		me.my_canvas2.set("background", "#f0f0f0");
		me.root2 = me.my_canvas2.createGroup();
		var filename2 = "/Aircraft/SL20/Instruments/MovingMap/Beschriftung.svg";
		me.svg_symbol2 = me.root2.createChild('group');
		canvas.parsesvg(me.svg_symbol2, filename2);
		me.Ta0 = me.svg_symbol2.getElementById("Kartentyp");
		me.Ta1 = me.svg_symbol2.getElementById("Zoomwert");
		me.uTimer = maketimer(2, func me.update());
		me.uTimer.start();
		me.my_canvas.addEventListener("wheel", func(e) {
			me.changeZoom(e.deltaY);
		});
	},
	update : func
    {
		if (me.map_type == 0)
		{
			me.Ta0.setText("Straßen");
		}
		else
		{
			me.Ta0.setText("Terrain");
		}
		me.Ta1.setText(sprintf("%.1f km", me.TestMap.getRange() * 1.852));
		me.svg_symbol.setRotation(getprop('/orientation/heading-deg') * D2R);
		if (getprop("/sim/model/SL20/map-track-visible"))
		{
			me.svg_symbolT.show();
			me.svg_symbolT.setRotation(getprop('/orientation/track-deg') * D2R);
		}
		else
		{
			me.svg_symbolT.hide();
		}
		if (getprop("/sim/model/SL20/map-wind-visible"))
		{
			me.svg_symbolA.show();
			me.svg_symbolA.setRotation(getprop('/environment/wind-from-heading-deg') * D2R);
		}
		else
		{
			me.svg_symbolA.hide();
		}
		setprop("/sim/gui/dialogs/SL20/map-canvas/draw-FLT", getprop("/sim/model/SL20/map-route-visible"));
	},
	showMDlg : func()
	{
		var dlg = canvas.Window.new([600, 400], "dialog").set("resize", 0).set("title", "Karte");
		dlg.setCanvas(me.my_canvas);
}
};

var MAP =  MAP_Device.new("Karte", "MDisplay",0);

setlistener("/sim/signals/fdm-initialized", func { MAP.init();
});
